@article{holepunching,
  author = {Ford, Bryan and Srisuresh, Pyda and Kegel, Dan},
  title = {Peer-to-Peer Communication Across Network Address Translators},
  year = {(2017)},
}

@misc{ice4j,
  author = {{Jitsi, społeczność open source}},
  title = {{Projekt ice4j}},
  note = {Ostatni dostęp 10.08.2023, \url{github.com/jitsi/ice4j}}
}

@misc{zxing,
  author = {{Społeczność open source}},
  title = {{Projekt zxing}},
  note = {Ostatni dostęp 10.08.2023, \url{github.com/zxing/zxingj}}
}

@misc{moby,
  author = {{Społeczność open source}},
  title = {{Projekt moby}},
  note = {Ostatni dostęp 10.08.2023, \url{github.com/moby/moby}}
}

@misc{docker_cli,
  author = {{Społeczność open source}},
  title = {{Projekt Docker CLI}},
  note = {Ostatni dostęp 10.08.2023, \url{github.com/docker/cli}}
}

@misc{docker_compose,
  author = {{Społeczność open source}},
  title = {{Projekt Docker Compose}},
  note = {Ostatni dostęp 10.08.2023, \url{github.com/docker/compose}}
}

@misc{apilevels,
  author = {{Eugene Belinski, społeczność open source}},
  title = {{Projekt apilevels}},
  note = {Ostatni dostęp 10.08.2023, \url{github.com/ebelinski/apilevels}}
}

@misc{tcp_tcp_wireguard,
  author = {{Wireguard}},
  title = {Known Limitations},
  note = {Ostatni dostęp 10.08.2023, \url{www.wireguard.com/known-limitations/}}
}

@misc{tcp_tcp_openvpn,
  author = {{OpenVPN}},
  title = {What is TCP Meltdown?},
  note = {Ostatni dostęp 10.08.2023, \url{openvpn.net/faq/what-is-tcp-meltdown/}}
}

@article{cstates,
  author = {Intel},
  title = {12th Generation Intel® Core™ Processors Datasheet, Volume 1 of 2},
  year = {(2021)},
  chapter = {Package C-States}
}

@article{cstates_dell,
  author = {Stuart Hayes},
  title = {Controlling Processor C-State
Usage in Linux},
  year = {(2013)},
}

@misc{tailscale,
    author = {David Anderson},
    title = {How NAT traversal works},
    year = {2020},
    note = {Ostatni dostęp 10.08.2023, \url{tailscale.com/blog/how-nat-traversal-works/}}
}

@misc{okhttp_license,
    author = {{Square, społeczność open source}},
    title = {{projekt okhttp}},
    note = {Ostatni dostęp 10.08.2023, \url{github.com/square/okhttp}}
}

@misc{jetty_license,
    author = {{Eclipse Foundation, społeczność open source}},
    title = {{projekt Eclipse Jetty}},
    note = {Ostatni dostęp 10.08.2023, \url{projects.eclipse.org/projects/rt.jetty}}
}

@misc{rfc4787_udp,
    series =    {Request for Comments},
    number =    4787,
    howpublished =  {RFC 4787},
    publisher = {RFC Editor},
    doi =       {10.17487/RFC4787},
    url =       {https://www.rfc-editor.org/info/rfc4787},
        author =    {Cullen Fluffy Jennings and Francois Audet},
    title =     {{Network Address Translation (NAT) Behavioral Requirements for Unicast UDP}},
    pagetotal = 29,
    year =      2007,
    month =     jan,
    abstract =  {This document defines basic terminology for describing different types of Network Address Translation (NAT) behavior when handling Unicast UDP and also defines a set of requirements that would allow many applications, such as multimedia communications or online gaming, to work consistently. Developing NATs that meet this set of requirements will greatly increase the likelihood that these applications will function properly. This document specifies an Internet Best Current Practices for the Internet Community, and requests discussion and suggestions for improvements.},
}

@misc{rfc5128_edm,
    series =    {Request for Comments},
    number =    5128,
    howpublished =  {RFC 5128},
    publisher = {RFC Editor},
    doi =       {10.17487/RFC5128},
    url =       {https://www.rfc-editor.org/info/rfc5128},
        author =    {Bryan Ford and Dan Kegel and Pyda Srisuresh},
    title =     {{State of Peer-to-Peer (P2P) Communication across Network Address Translators (NATs)}},
    pagetotal = 32,
    year =      2008,
    month =     mar,
    abstract =  {This memo documents the various methods known to be in use by applications to establish direct communication in the presence of Network Address Translators (NATs) at the current time. Although this memo is intended to be mainly descriptive, the Security Considerations section makes some purely advisory recommendations about how to deal with security vulnerabilities the applications could inadvertently create when using the methods described. This memo covers NAT traversal approaches used by both TCP- and UDP-based applications. This memo is not an endorsement of the methods described, but merely an attempt to capture them in a document. This memo provides information for the Internet community.},
}


@book{nowak2018,
  author = {Jan Nowak},
  year = {(2008)},
  title = {The title of the book},
  publisher = {Wydawca},
  address = {Wrocław},
  edition = {2}
}

@misc{rfc2663,
    series =    {Request for Comments},
    number =    2663,
    howpublished =  {RFC 2663},
    publisher = {RFC Editor},
    doi =       {10.17487/RFC2663},
    url =       {https://www.rfc-editor.org/info/rfc2663},
        author =    {Matt Holdrege and Pyda Srisuresh},
    title =     {{IP Network Address Translator (NAT) Terminology and Considerations}},
    pagetotal = 30,
    year =      1999,
    month =     aug,
    abstract =  {This document attempts to describe the operation of NAT devices and the associated considerations in general, and to define the terminology used to identify various flavors of NAT. This memo provides information for the Internet community.}
}